import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.lang.String;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;



public class Model {
	

	
	 public static void main(String[] args) {
		
		 
		 try {
		  		if(Parameters.writeOutputStreamToFile){
			  		File file = new File("output.txt");
					FileOutputStream fos = new FileOutputStream(file);
					PrintStream ps = new PrintStream(fos);
					System.setOut(ps);
		  		}
		  		
		  		
		  		Stopwatch stopWatch = new Stopwatch();
		  		stopWatch.start();
		  			  		
		  		
// ---------------------------------------------- Import data file ----------------------------------------------------- 

		
		  		
		  		FileInputStream fileInputStream = new FileInputStream(Parameters.problemFile+".xls");
				HSSFWorkbook workbook = new HSSFWorkbook(fileInputStream);
				

 // ----------------------------------------- Build problem -------- ----------------------------------------------- 
				
				
				if(Parameters.runModel_One){
					Problem problem = new Problem(workbook);
					
					
				
					
					PathFinder pathfinder = new PathFinder(problem);
					
					stopWatch.stop();
					
					System.out.println("*****************************************************************************************************************************************");
		  		    System.out.println("Runtime: " + String.format( "%.5f",stopWatch.getElapsedTime()*0.001) + " [s]");
		  		    System.out.println("*****************************************************************************************************************************************");
		  		    System.out.println();
		  		    
		  		  checkTracker(pathfinder);
		  		  if(Parameters.printTextFileProblem1){
		  			printTextFileProblem1(problem, pathfinder);
		  		  }
				
				
				}
				else if(Parameters.runModel_Two){
					
					Problem2 problem = new Problem2(workbook, stopWatch);
					PathFinder pathfinder = new PathFinder(problem);
					stopWatch.stop();
					
					System.out.println("*****************************************************************************************************************************************");
		  		    System.out.println("Runtime: " + String.format( "%.5f",stopWatch.getElapsedTime()*0.001) + " [s]");
		  		    System.out.println("*****************************************************************************************************************************************");
		  		    System.out.println();
		  		    
		  		    if(Parameters.printPaths){
			  			printPaths(problem, pathfinder);
			  		}
			  		
		  		  checkTracker(pathfinder);
		  		  if(Parameters.printTextFileProblem2){
			  		printTextFileProblem2(problem, pathfinder);
		  		  }
				}
				

			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
				
		  	}
	 }
	 
	 
	 private static void write(String s, String filename) throws FileNotFoundException
	 {
		 PrintWriter out = new PrintWriter(filename);
		 
		 out.println(s);
		 out.close();
		 
	 }
	 
	 private static void printTextFileProblem1(Problem problem, PathFinder pathfinder){
		 if(pathfinder.completeLabels.isEmpty()==false){ // Vil kun skrive ut dersom det er feasible 
				
				String textstr = new String("");
		  		
			  	int nCargoes = problem.getNumberOfNodes()-2;
			  		
			  	textstr = "nCargoes : " + nCargoes + " " + "\n" + "Nodes : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
			  		textstr = textstr + problem.getNodes().get(i).getNodeNumber() + " ";
			  	}
			  	textstr = textstr + "]" + " " + "\n"  +"PickupNodes : [";
			  		
			  	for(int i = 0; i < problem.findPickupNodes().size(); i++){
			  		textstr = textstr + problem.findPickupNodes().get(i).getNodeNumber() + " ";
			  	}
			  	textstr = textstr + "]" + " " + "\n"  +"DeliveryNodes : [";
			  		
			  	for(int i = 0; i < problem.findDeliveryNodes().size(); i++){
			  		textstr = textstr + problem.findDeliveryNodes().get(i).getNodeNumber() + " ";
			  	}
			  	textstr = textstr + "]" + " " + "\n"  +"TimeBetweenNodes : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
					for(int j = 0; j < problem.getNumberOfNodes(); j++){
						textstr = textstr + problem.getTimeBetweenNodes()[i][j] + " ";
					}
			  	}
			  	textstr = textstr + "]" + " " + "\n"  +"Capacity : " + problem.getVessel().getShipCapacity() + " " + "\n" + "DraftLimit : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
			  		textstr = textstr + problem.getNodes().get(i).getAssociatedTerminal().getDraftLimit() + " ";
			  	}
			  		
			  	textstr = textstr + "]" + " " + "\n" +"TotalDeliveryLoad : [" + problem.getTotalDeliveryLoad() + "]" + " " + "\n" + "TotalPickupLoad : [" + problem.getTotalPickupLoad() + "]" + " " + "\n" + "CargoLoad : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
			  		textstr = textstr + problem.getNodes().get(i).getCargoLoad() + " ";
			  	}
			  		
			  	textstr = textstr + "]" + " " + "\n"  +"LowerTimeWindow : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
			  		textstr = textstr + problem.getNodes().get(i).getLowerTimeWindow() + " ";
			  	}
			  		
			  	textstr = textstr + "]" + " " + "\n"  +"UpperTimeWindow : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
			  		textstr = textstr + problem.getNodes().get(i).getUpperTimeWindow() + " ";
			  	}
			  		
			  	textstr = textstr + "]" + " " + "\n"  +"BigM : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
					for(int j = 0; j < problem.getNumberOfNodes(); j++){
						textstr = textstr + problem.getBigM()[i][j] + " ";
					}
			  	}
			  		
			  	textstr = textstr + "]" + " " + "\n"  +"A : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
					for(int j = 0; j < problem.getNumberOfNodes(); j++){
						textstr = textstr + problem.getArcs()[i][j] + " ";
					}
			  	}
			  		
			  	textstr = textstr + "]" + "\n";
			 	
			  	try{
					write(textstr, Parameters.problemFile + ".txt");
					} catch(FileNotFoundException e)
					{
					}
				
			}
		 
		 
	 }
			  	 
	 private static void printPaths(Problem2 problem, PathFinder pathfinder){

	  			ArrayList<Label> completeL = pathfinder.getCompleteLabels();
		  		
				ArrayList<int[ ][ ]> paths = new ArrayList<int[ ][ ]>();
				
				for(Label l : completeL){
					int[ ][ ] zMatrix = new int[problem.getNumberOfNodes()+2][problem.getNumberOfNodes()+2];
					for(int i = 0; i < problem.getNumberOfNodes(); i++){
						for(int j = 0; j < problem.getNumberOfNodes(); j++){
							zMatrix[i][j]=0;
						}
					}
					
					for(int i = 0; i < l.getVisitedNodes().size(); i++){
						zMatrix[l.getVisitedNodes().get(i).getNodeNumber()][i] = 1;
					}
					paths.add(zMatrix); 
				}
				
				
				for(int nr = 0; nr < paths.size(); nr++){
					String str="";
					int nrplus1 = nr+1;
					str = str + "z: [";
					 for(int i = 0; i < problem.getNumberOfNodes(); i++){
						 for(int j = 0; j < problem.getNumberOfNodes(); j++){
							 str = str + paths.get(nr)[i][j] + " ";
						 }
					 }
					str = str + " ]" + "\n";
				
					try{
						write(str, "paths_" + Parameters.problemFile + "_" + nrplus1 + ".txt");
						} catch(FileNotFoundException e)
						{
						}
				}
	  			
	  		}
	 
	 private static void printTextFileProblem2(Problem2 problem, PathFinder pathfinder){
		 if(pathfinder.completeLabels.isEmpty()==false){ // Vil kun skrive ut dersom det er feasible 
			 if(Problem2.feasibleProblem){
				
				String textstr = new String("");
		  		
			  	int nCargoes = problem.getNumberOfNodes()-2;
			  		
			  	textstr = "nCargoes : " + nCargoes + " " + "\n" + "Sequence: [";
			  	
				for(int i = 0; i < problem.getNumberOfNodes(); i++){
			  		textstr = textstr + problem.getNodes().get(i).getNodeNumber() + " ";
			  	}
			  			
				textstr = textstr + "]" + "Nodes : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
			  		textstr = textstr + problem.getNodes().get(i).getNodeNumber() + " ";
			  	}
			  	
			  	textstr = textstr + "]" + "NodesNotAnchorage : [";
		  		
			  	for(int i = 1; i < problem.getNumberOfNodes()-1; i++){
			  		textstr = textstr + problem.getNodes().get(i).getNodeNumber() + " ";
			  	}
			  	textstr = textstr + "]" + "\n"  +"PickupNodes : [";
			  		
			  	for(int i = 0; i < problem.findPickupNodes().size(); i++){
			  		textstr = textstr + problem.findPickupNodes().get(i).getNodeNumber() + " ";
			  	}
			  	textstr = textstr + "]" + " " + "\n"  +"DeliveryNodes : [";
			  		
			  	for(int i = 0; i < problem.findDeliveryNodes().size(); i++){
			  		textstr = textstr + problem.findDeliveryNodes().get(i).getNodeNumber() + " ";
			  	}
			  	textstr = textstr + "]" + " " + "\n"  +"TimeBetweenNodes : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
					for(int j = 0; j < problem.getNumberOfNodes(); j++){
						textstr = textstr + problem.getTimeBetweenNodes()[i][j] + " ";
					}
			  	}
			  	textstr = textstr + "]" + " " + "\n"  +"Capacity : " + problem.getVessel().getShipCapacity() + " " + "\n" + "DraftLimit : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
			  		textstr = textstr + problem.getNodes().get(i).getAssociatedTerminal().getDraftLimit() + " ";
			  	}
			  	
			  	textstr = textstr + "]" + " " + "\n" +"TotalDeliveryLoad : [" + problem.getTotalDeliveryLoad() + "]" + " " + "\n" + "TotalPickupLoad : [" + problem.getTotalPickupLoad() + "]" + " " + "\n" ;
			  	
			  	textstr = textstr +"VolumeCargo: [";
			  	
			  	for(Node n : problem.getNodes()){
			  		textstr = textstr + n.getCargoLoadVolume() + " ";
				}
			  
			  	textstr = textstr+ "]" + " " + "\n" + "CargoLoad : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
			  		textstr = textstr + problem.getNodes().get(i).getCargoLoad() + " ";
			  	}
			  		
			  	textstr = textstr + "]" + " " + "\n"  +"LowerTimeWindow : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
			  		textstr = textstr + problem.getNodes().get(i).getLowerTimeWindow() + " ";
			  	}
			  		
			  	textstr = textstr + "]" + " " + "\n"  +"UpperTimeWindow : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
			  		textstr = textstr + problem.getNodes().get(i).getUpperTimeWindow() + " ";
			  	}
			  		
			  	textstr = textstr + "]" + " " + "\n"  +"BigM : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
					for(int j = 0; j < problem.getNumberOfNodes(); j++){
						textstr = textstr + problem.getBigM()[i][j] + " ";
					}
			  	}
			  		
			  	textstr = textstr + "]" + " " + "\n"  +"A : [";
			  		
			  	for(int i = 0; i < problem.getNumberOfNodes(); i++){
					for(int j = 0; j < problem.getNumberOfNodes(); j++){
						textstr = textstr + problem.getArcs()[i][j] + " ";
					}
			  	}
			  		
			  	textstr = textstr + "]" + "\n" + "nTanks: [" + problem.getTanks().size() + "]" + "\n";
			  		
			  	textstr = textstr + "Tanks: [";
			  	for(int i = 0; i < problem.getTanks().size(); i++){
			  		textstr = textstr + problem.getTanks().get(i).getTankID() + " ";
			  	}
			  	textstr = textstr + "]" + "\n";
			  	
			  	textstr = textstr + "MinCapTank: [";
			  	for(int i = 0; i < problem.getTanks().size(); i++){
			  		textstr = textstr + problem.getTanks().get(i).getMinCap() + " ";
			  	}
			  	textstr = textstr + "]" + "\n";
			  	
			  	textstr = textstr + "MaxCapTank: [";
			  	for(int i = 0; i < problem.getTanks().size(); i++){
			  		textstr = textstr + problem.getTanks().get(i).getMaxCap() + " ";
			  	}
			  	textstr = textstr + "]" + "\n";
			  	
			  	textstr = textstr + "InitialLoadOnTank: [";
		  		for(int i = 0; i < problem.getNumberOfNodes()-2; i++){
					for(int j = 0; j < problem.getTanks().size(); j++){
						textstr = textstr + (problem.getInitialPlacements()[i][j] + " ");
					}
				}
		  		textstr = textstr + "]" + "\n";
		  		
		  		textstr = textstr + "InitialVolumeOnTank: [";
		  		for(int i = 0; i < problem.getNumberOfNodes()-2; i++){
					for(int j = 0; j < problem.getTanks().size(); j++){
						textstr = textstr + (problem.getInitialVolume()[i][j] + " ");
					}
				}
		  		textstr = textstr + "]" + "\n";
			  	
			  	
		  		
			  	if(Parameters.nothingIncompatible){ //alle mengdene skal vre tomme
			  		textstr = textstr + "LoadsInConflict: [";
			  		for(int i = 1; i < problem.getNodes().size()-1; i++){
			  			textstr = textstr + "[]";
			  		}
			  		textstr = textstr + "]" + "\n";
			  			
			  		textstr = textstr + "LoadsCompWTank: [";
			  		for(int j=0; j < problem.getTanks().size(); j++){
			  			textstr = textstr + "[";
			  			for(int i=1; i < problem.getNodes().size()-1; i++){
			  				textstr = textstr + problem.getNodes().get(i).getNodeNumber() + " ";
			  			}
			  			textstr = textstr + "]";
			  		}
			  		textstr = textstr + "]" + "\n";
			  		
			  		textstr = textstr + "TanksCompWLoad: [";
			  		for(int j=1; j < problem.getNodes().size()-1; j++){
			  			textstr = textstr + "[";
			  			for(int i=0; i < problem.getTanks().size(); i++){
			  				textstr = textstr + problem.getTanks().get(i).getTankID() + " ";
			  			}
			  			textstr = textstr + "]";
			  		}
			  		textstr = textstr + "]" + "\n";
			  		
			  	/*	//mengden som definerer laster inkompatible med andre laster. F_ijf 
			  		textstr = textstr + "TanksIncompWLoadGivenLoadOnTank: [";
			  		for(int j=0; j < (problem.getNodes().size()-2)*(problem.getNodes().size()-2)*(problem.getTanks().size()); j++){  //Har laget en array for  beskrive en tredimensjonal matrise pga mten det leses inn i mosel p 
			  			for(int i=1; i < problem.getTanks().size()-1; i++){
			  				textstr = textstr +  "[]";
			  			}
			  		}
			  		
			  		textstr = textstr + "]" + "\n";*/
			  		
			
			  	} //end if nothingIncompatible
			  	
			  	
			  	else{ //har inkompabilitet
			  		
			  		textstr = textstr + "LoadsInConflict: [";
			  		for(int i = 1; i < problem.getNodes().size()-1; i++){
			  			textstr = textstr + "[]";
			  		}
			  		textstr = textstr + "]" + "\n";
			  		
			  		
			  		textstr = textstr + "LoadsCompWTank: [";
			  		for(int j=0; j < problem.getTanks().size(); j++){
			  			textstr = textstr + "[";
			  			for(int i=1; i < problem.getNodes().size()-1; i++){
			  				if(problem.getTanks().get(j).getTankType() == problem.getNodes().get(i).getCargoType() || problem.getNodes().get(i).getCargoType() == 3){ //type 3 betyr at load er kompatibel med begge lasttyper
			  					textstr = textstr + problem.getNodes().get(i).getNodeNumber() + " ";
			  				}
			  			}
			  			textstr = textstr + "]";
			  		}
			  		textstr = textstr + "]" + "\n";
			  		
			  		textstr = textstr + "TanksCompWLoad: [";
			  		for(int j=1; j < problem.getNodes().size()-1; j++){
			  			textstr = textstr + "[";
			  			for(int i=0; i < problem.getTanks().size(); i++){
			  				if(problem.getNodes().get(j).getCargoType() == problem.getTanks().get(i).getTankType() || problem.getNodes().get(j).getCargoType() == 3){ //type 3 betyr at load er kompatibel med begge lasttyper
			  					textstr = textstr + problem.getTanks().get(i).getTankID() + " ";
			  				}
			  			}
			  			textstr = textstr + "]";
			  		}
			  		textstr = textstr + "]" + "\n";
			  		
			  		/* //mengden som definerer laster inkompatible med andre laster. F_ijf 
			  		textstr = textstr + "TanksIncompWLoadGivenLoadOnTank: [";
			  		for(int j=0; j < (problem.getNodes().size()-2)*(problem.getNodes().size()-2)*(problem.getTanks().size()); j++){  
			  			for(int i=1; i < problem.getTanks().size()-1; i++){
			  				textstr = textstr +  "[]";
			  			}
			  		}
			  		
			  		textstr = textstr + "]" + "\n";
			  		*/
			  		
			  	}
			 
			 		

			  	
			  	try{
			  		if(Parameters.nothingIncompatible){
			  			write(textstr, "fixedRoute_" + Parameters.problemFile + ".txt");
					}
			  		else{
			  			write(textstr, "fixedRoute_WithIncomp_" + Parameters.problemFile + ".txt");
			  		}
			  		}
					 catch(FileNotFoundException e)
					{
					}
			 } 
			}

	 }
		 
	 private static void checkTracker(PathFinder pathfinder){
		 System.out.println("Number of times check 2 occurs: " + pathfinder.counterCheck2);
			System.out.println("Number of times check 3 occurs: " + pathfinder.counterCheck3);
			System.out.println("Number of times check 4 occurs: " + pathfinder.counterCheck4);
		    System.out.println("Number of times check 5 (extra time check) occurs: " + pathfinder.counterCheck5);
		    System.out.println("Number of times check 6 (extra draft limit check) occurs: " + pathfinder.counterCheck6);
	  		System.out.println("Number of times check 7 occurs: " + pathfinder.counterCheck7);
	  		System.out.println("Number of times check 8 occurs: " + pathfinder.counterCheck8);
	  		System.out.println("Number of times check 9 occurs: " + pathfinder.counterCheck9);
	  		System.out.println("Number of times check 10 occurs: " + pathfinder.counterCheck10);
	  		System.out.println("Number of times check 11 occurs: " + pathfinder.counterCheck11);
	  		System.out.println("Number of times check 12 occurs: " + pathfinder.counterCheck12);
	  		System.out.println("Number of times domination criteria is run: " + pathfinder.counterDom);
	  		System.out.println("Number of labels generated: " + pathfinder.numberOfLabelsGenerated);
	 }
}
