import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;

import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;

public class Node {

	private int nodeNumber;  
	private Terminal associatedTerminal; 
	private int pOrD; 				//+-1, 0 hvis anchorage
	//public String cargoDescription; 
	private double washingTime; 
	private double cargoLoad;
	private double loadingTime;
	private double lowerTimeWindow;
	private double upperTimeWindow;
	private double density;
	private double cargoLoadVolume;
	private int cargoType;
	private double nodeID;
	private ArrayList<Node> neighbours;

	public Node(int aa, Terminal bb, int cc, double dd, double ee, double ff, double gg, double hh, double dens, int type){
		nodeNumber = aa;
		associatedTerminal = bb;
		pOrD = cc;
		washingTime = dd;
		cargoLoad = ee;
		loadingTime = ff;
		lowerTimeWindow = gg;
		upperTimeWindow = hh;
		density = dens;
		cargoType = type;
		nodeID = findNodeID();
		cargoLoadVolume = findCargoLoadVolume();
	}
	
	
	public int getNodeNumber() {
		return nodeNumber;
	}

	public double getNodeID(){
		return nodeID;
	}

	public Terminal getAssociatedTerminal() {
		return associatedTerminal;
	}


	public int getpOrD() {
		return pOrD;
	}


	public double getWashingTime() {
		return washingTime;
	}



	public double getCargoLoad() {
		return cargoLoad;
	}

	public double getCargoLoadVolume() {
		return cargoLoadVolume;
	}


	public double getLoadingTime() {
		return loadingTime;
	}



	public double getLowerTimeWindow() {
		return lowerTimeWindow;
	}



	public double getUpperTimeWindow() {
		return upperTimeWindow;
	}
	
	
	public double getDensity() {
		return density;
	}

	public int getCargoType() {
		return cargoType;
	}

	public ArrayList<Node> getNeighbours() {
		return neighbours;
	}

	public void setNeighbours(ArrayList<Node> neighbours) {
		this.neighbours = neighbours;
	}

	private double findNodeID(){
		double ID = Math.pow(2, nodeNumber);
		return ID;
	}
	
	private double findCargoLoadVolume(){
		if(pOrD == 0){
			return 0;
		}
		return ((cargoLoad*1000)/density);
	}
	
	

	

}
