import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Collections;
import java.math.*;
import java.util.Comparator;

public class PathFinder {
	
	Problem problem;
	ArrayList<Label> unprocessedLabels;
	//ArrayList<Label> usefulLabels;
	ArrayList<Label> completeLabels;
	ArrayList<Label> completeSortedLabels;
	int nCreatedLabels;

//	boolean printExtension = false;
//	boolean printDominance = false;

	
	
	public int counterCheck2 = 0;
	public int counterCheck3 = 0;
	public int counterCheck4 = 0;
	public int counterCheck5 = 0;
	public int counterCheck6 = 0;
	public int counterCheck7 = 0;
	public int counterCheck8 = 0;
	public int counterCheck9 = 0;
	public int counterCheck10 = 0;
	public int counterCheck11 = 0;
	public int counterCheck12 = 0;
	public int counterDom = 0;
	
	public int numberOfLabelsGenerated=0;

	
	
	
	
	public PathFinder(Problem problem) {
		this.problem = problem;
		this.unprocessedLabels = new ArrayList<Label>();
		//this.usefulLabels = new ArrayList<Label>();
		this.completeLabels = new ArrayList<Label>();
		completeSortedLabels = findPaths();
		
	}
	
	
	//-------------------------------Lage startlabel---------------------------------------------------------------------------//
	
	public Label calcStartLabel(){
		

		Node n = problem.getNodes().get(0);
		ArrayList<Node> visitedNodes = new ArrayList<Node>(); 
		visitedNodes.add(n);

		return (new Label(0, n, 0, problem.getTotalDeliveryLoad(), visitedNodes));
		
	}
	
	//-------------------------------Overordnet metode---------------------------------------------------------------------------//
	
	
	public ArrayList<Label> findPaths(){
		
		Label label = calcStartLabel();
		unprocessedLabels.add(label);
		
		
		while (unprocessedLabels.isEmpty() == false){
			
			//Finner nextNumberToExtend: indeksen til neste label som skal extendes. Bredde frst (de med frrest antall beskte noder), deretter velge den med kortest tid av disse.
			int nextNumberToExtend = 0;
			Label nextLabelToExtend = unprocessedLabels.get(0);
			int numberOfNodesOnNextLabel = nextLabelToExtend.getVisitedNodes().size();
			
			for(Label next : unprocessedLabels) {
				if(numberOfNodesOnNextLabel == next.getVisitedNodes().size()){ //skal g gjennom de frste i unprocessedLabels-lista til ant beskte noder endres.
					if(next.getArrivalTime() < nextLabelToExtend.getArrivalTime()){
						nextLabelToExtend = next; 
						nextNumberToExtend = unprocessedLabels.indexOf(nextLabelToExtend);
					}
				}
				else{
					break;
				}
			}
			
			
			
			Label l = unprocessedLabels.remove(nextNumberToExtend);
			
			// Finn alle extensions
			ArrayList<Label> extendedLabels = extendLabel(l);
			
			extendedLabels = dominanceCheck(extendedLabels,unprocessedLabels); //dominansesjekk
	
			
			for(int i = 0; i < extendedLabels.size(); i++){	
				unprocessedLabels.add(extendedLabels.get(i));											// Ikke fullfrte ruter: Labels legges unprocessed labels
			}
			
			
			
			// Dominanssjekk
		
			/*for(int i = 0; i < extendedLabels.size(); i++){													// Dominanssjekk kun p de labels som ikke slutter i siste noden (nsker  spare p alle complete labels)
				
				if(extendedLabels.get(i).getVisitedNodes().size() < problem.getNumberOfNodes()){
					extendedLabels = dominanceCheck(extendedLabels,unprocessedLabels);
				}
				else{
					continue;
				}
			}	
			
			for(int i = 0; i < extendedLabels.size(); i++){	
	
				if(extendedLabels.get(i).getVisitedNodes().size() == problem.getNumberOfNodes()){			// Fullfrte ruter: Labels legges i complete labels 
					
					completeLabels.add(extendedLabels.get(i));	
				}
				else{		
					unprocessedLabels.add(extendedLabels.get(i));											// Ikke fullfrte ruter: Labels legges unprocessed labels
				}
				
			}*/
					
		}
		
		
		System.out.println("*****************************************************************************************************************************************");
		System.out.println("No more unprocessed labels, search finished");
		System.out.println();
		
		if(Parameters.runModel_Two){
			
			// Sortering av labels etter total tid brukt - kun dersom flere complete labels lagres
			Collections.sort(completeLabels, new LabelComparator());
			
		}
		
		// PRINT
		System.out.println("Completed labels:");
			for(int i = 0; i < completeLabels.size(); i++) {   
				System.out.print((i+1) + ":");
				System.out.println(completeLabels.get(i));					
				} 
			
			
		return completeLabels; 
	}
	

	
	public ArrayList<Label> getCompleteLabels() {
		return completeLabels;
	}
	
	//-------------------------------Sjekkliste---------------------------------------------------------------------------//

		

	public boolean equalOrGreaterTimeWindows(Node pickup, Node delivery){
		boolean equal = false;
		
		if(pickup.getLowerTimeWindow() >= delivery.getLowerTimeWindow() && pickup.getUpperTimeWindow() >= delivery.getUpperTimeWindow()){ 
			equal = true;
		}
		
		return equal; 
	}
	
/*	public ArrayList<Node> nodesInSameTerminal(Node n){
		ArrayList<Node> nodesInSameTerm = new ArrayList<Node>();
		
		for(Node i : problem.getNodes()){
			if(i != n && i.getAssociatedTerminal().getTerminalID() == n.getAssociatedTerminal().getTerminalID()){
				nodesInSameTerm.add(i);
			}
		}
		return nodesInSameTerm;
	}*/

	public ArrayList<Node> remainingPickups(Label l){
		ArrayList<Node> pickups = new ArrayList<Node>();
		
		for(Node n : problem.getNodes()){
			if(l.getVisitedNodes().contains(n)==false && n.getpOrD()==1){
				pickups.add(n);
			}
		}
		return pickups;
	}
	
	public ArrayList<Node> remainingDeliveries(Label l){
		ArrayList<Node> deliveries = new ArrayList<Node>();
		
		for(Node n : problem.getNodes()){
			if(l.getVisitedNodes().contains(n)==false && n.getpOrD()==-1){
				deliveries.add(n);
			}
		}
		return deliveries;
	}
	
	public ArrayList<Node> CheckNodesInSameTerminal(Terminal t, Label l){				// For en terminal og en label: sjekker om alle nodene i terminalen er beskt og er beskt etter hverandre, returerer rekkeflgen 
		
		ArrayList<Node> visitedNodesInSameTerminal = new ArrayList<Node>();
		
		for( int n=1; n < l.getVisitedNodes().size(); n++){
			
			if(l.getVisitedNodes().get(n).getAssociatedTerminal().getTerminalID() == t.getTerminalID() && problem.getNumberOfNodesInTerminal()[t.getTerminalID()] > 1){			// Hvis noden er i terminal vi ser p, og antall noder i terminalen er strre enn 1 (ingen terminaler har null)
				
				visitedNodesInSameTerminal.add(l.getVisitedNodes().get(n));
				
				for(int m=1; m < problem.getNumberOfNodesInTerminal()[t.getTerminalID()] ; m++ ){
					
					if(n+m <= l.getVisitedNodes().size()-1){										// Hvis ikke alle nodene i samme terminal er beskt (visitedNodes er for liten)
						
						if(l.getVisitedNodes().get(n).getAssociatedTerminal().getTerminalID() == l.getVisitedNodes().get(n+m).getAssociatedTerminal().getTerminalID()){
							
							visitedNodesInSameTerminal.add(l.getVisitedNodes().get(n+m));
								
							if(visitedNodesInSameTerminal.size() == problem.getNumberOfNodesInTerminal()[t.getTerminalID()]){	// Hvis alle noder er beskt i rekkeflge, returner mengden av noder 
								return visitedNodesInSameTerminal;
							}
							else{
								continue;
							}
						}
						else{
							return visitedNodesInSameTerminal = null;				// Hvis ikke de pflgende nodene har samme terminalID - returner null
						}
						
					}
					else{
						return visitedNodesInSameTerminal = null;					// Hvis visitedNodes inneholder 1 (feks som siste element), men ikke 2 og 3 (har ikke kommet hit enda - visitedNodes er for liten) - returner null
					}
						
				}
		
			}
			else{
				continue;
				
			}
		}
		
		
		return visitedNodesInSameTerminal;
	}
	
	public ArrayList<Terminal> visitedTerminals(Label l){				//frste element er mest nylig beskt, inneholder ikke anchorage
		ArrayList<Terminal> visitedTerminals = new ArrayList<Terminal>();
		

		for(int i = l.getVisitedNodes().size()-1; i>0; i--){
			Node n = l.getVisitedNodes().get(i);
			if(n.getpOrD() != 0 && visitedTerminals.contains(n.getAssociatedTerminal()) == false){
				visitedTerminals.add(n.getAssociatedTerminal());
			}
		}
		return visitedTerminals;
	}

	public boolean bothArcsExists(Node i, Node j){
		if(problem.getArcs()[i.getNodeNumber()][j.getNodeNumber()]==1 && problem.getArcs()[j.getNodeNumber()][i.getNodeNumber()]==1){
			return true; 
		}
		return false;
	}
	
	public boolean Check1(Label l){ 	// True hvis du fortsatt mangler  beske noen av kundene

		if(l.getVisitedNodes().size() < problem.getNumberOfNodes() -1){
			return true; 
		}
		return false;
	}
	

	
	public boolean CheckArcs(Node currentNode, Node newNode){		// True hvis det finnes en bue fra currentNode og til newNode
		if(problem.getArcs()[currentNode.getNodeNumber()][newNode.getNodeNumber()] == 1 ){
			return true;
		}
		return false;
	}
	
	/*public boolean Check2(double newArrivalTime, Node newNode){			//Tidssjekk - GAMMEL
		if(newArrivalTime <= newNode.getUpperTimeWindow()){
			return true;
		}
		return false;
	}*/
	
	public boolean Check2(ArrayList<Node> notVisited, double newArrivalTime, Node newNode){			//Utvidet timecheck. True hvis det er mulig
	
		boolean timeCheck = true;						// Ekstra tidssjekk: sjekker til de neste mulige utvidelsene
		if(notVisited.size()>1){
			for(Node n2 : notVisited){
				double newNewArrivalTime = newArrivalTime + problem.getTimeBetweenNodes()[newNode.getNodeNumber()][n2.getNodeNumber()];
					if(n2.getNodeNumber() != newNode.getNodeNumber() && newNewArrivalTime > n2.getUpperTimeWindow()){
						timeCheck = false;
						break;
					}
			}
		}
		return timeCheck;
	}
	
	public boolean Check3(double newLoad, Node newNode, Label l){ // DraftLimit check. True hvis det er mulig 
		if(newNode.getpOrD()==1){
			if(newLoad <= Math.min(problem.getVessel().getShipCapacity(),newNode.getAssociatedTerminal().getDraftLimit())){
				return true;
			}
		}
		else if(newNode.getpOrD()==-1){
			if(l.getAccumulatedLoad() <= newNode.getAssociatedTerminal().getDraftLimit()){
				return true; 
			}
		}
				
		return false;
	}
	
	public boolean Check4(Label l, Node j){		//Reducing symmetry
		ArrayList<Node> neighbours = new ArrayList<Node>();
		neighbours = j.getNeighbours();
		
		for(Node k : neighbours){
			if(k.getpOrD()==-1 && j.getpOrD()==1 && equalOrGreaterTimeWindows(j,k) == true && l.getVisitedNodes().contains(k)==false && problem.getArcs()[l.getCurrentNode().getNodeNumber()][k.getNodeNumber()]==1){
				return true;
			}
		}
		return false; 
	}
	
	public boolean Check5(ArrayList<Node> notVisited, Node newNode, double newLoad){			//Utvidet lastsjekk. True hvis det er mulig
		boolean loadCheck = true;
		
		if(notVisited.size() > 1){
			int numberOfPickup = 0;				//antall pickuploads av gjenvrende noder
			for (Node n : notVisited){
				if(n.getpOrD()==1){
					numberOfPickup = numberOfPickup + 1;
				}
			}
			
			if(numberOfPickup == notVisited.size()){				//Ekstra lastsjekk :sjekker til de neste mulige utvidelsene dersom det kun er pickuploads. 
				for(Node n2 : notVisited){
						if(n2.getNodeNumber() != newNode.getNodeNumber() && newLoad + n2.getCargoLoad() > n2.getAssociatedTerminal().getDraftLimit()){
							loadCheck = false;
							break;
						}
				}
			}
		}
		return loadCheck;
	}
	
	
	public boolean Check6(Label l, Node j, ArrayList<Node> notVisited){
		int numberOfDelivery = 0;
		for (Node n : notVisited){
			if(n != j && n.getpOrD()==-1){
				numberOfDelivery = numberOfDelivery + 1;
			}
		}
		
		
		if(numberOfDelivery == 1){
			Node theOnlyDelivery = null;
			for (Node n : notVisited){
				if(n != j && n.getpOrD()==-1){
					theOnlyDelivery = n;
				}
			}

			if(l.getAccumulatedLoad() + j.getCargoLoad() > theOnlyDelivery.getAssociatedTerminal().getDraftLimit()){
				return true; 
			}
		
		}

		return false; 
	}

	public boolean Check7(Label l, Node j){
		ArrayList<Node> pickups = new ArrayList<Node>();
		ArrayList<Node> deliveries = new ArrayList<Node>();
		double sumDeliveryCargo = 0;
		double loadAtJ = l.getAccumulatedLoad() + j.getCargoLoad();
		
		pickups = remainingPickups(l);
		deliveries = remainingDeliveries(l);
		
		for(Node n : deliveries){
			if(n != j && j.getpOrD()==1){
				sumDeliveryCargo = sumDeliveryCargo + n.getCargoLoad();
			}
		}
		
		for(Node n : pickups){
			
			if(n != j && j.getpOrD()==1 && (sumDeliveryCargo + loadAtJ > n.getAssociatedTerminal().getDraftLimit())){
				return true;
			}
		}
		return false; 
	}
	
	public boolean Check8(Label l, Node j){
		ArrayList<Node> pickups = new ArrayList<Node>();
		ArrayList<Node> deliveries = new ArrayList<Node>();
		pickups = remainingPickups(l);
		deliveries = remainingDeliveries(l);
		double loadAtJ = l.getAccumulatedLoad() + j.getCargoLoad();
		
		if(j.getpOrD()==1 && pickups.size() == 0){
			for(Node n : deliveries){
				if(n.getAssociatedTerminal().getDraftLimit() >= loadAtJ){
					return false;											//hvis draft limit er hyere eller lik loadAtJ for EN av nodene skal sjekken returnere false
				
				}
			}
		return true;
		}
		
		
		
		return false;
	}
	
	public boolean Check9(Label l, Node j, ArrayList<Node> notVisited){
		
		if(notVisited.size()==2 && j.getpOrD()==1){
			Node theRemainingNode = null;
			for(Node n:notVisited){
				if(n != j){
				theRemainingNode = n;
				}
			}
			if(theRemainingNode.getAssociatedTerminal().getDraftLimit() < problem.getTotalPickupLoad()){
				return true;
			}
		}
	return false;
	
	}
	
	
	public boolean Check10(Label l, Node j, ArrayList<Node> notVisited){
		ArrayList<Node> nodesInSameTerminal = new ArrayList<Node>();
		ArrayList<Node> nodesInSameTerminalRemaining = new ArrayList<Node>();
		nodesInSameTerminal = j.getNeighbours();
		
		if(j.getpOrD() == 1){

			for(Node n : nodesInSameTerminal){
				if(notVisited.contains(n)){
					nodesInSameTerminalRemaining.add(n);
				}
			}
	
	
			int numberOfPickups=0;
				
			for(Node n : nodesInSameTerminalRemaining){
				if(n.getpOrD()==1){
					numberOfPickups = numberOfPickups + 1;
				}
			}
			
			if(numberOfPickups == nodesInSameTerminalRemaining.size()){   		//bare pickup i samme terminal som j
				
				if(notVisited.size()>1) {
					for(Node n : notVisited){
						if(n.getpOrD() != 0 && n != j && n.getAssociatedTerminal().getDraftLimit() >= l.getAccumulatedLoad()+j.getCargoLoad()){
							return false; 
						}
					}
					return true; //hvis ingen andre noder har hy nok draft limit
				}
			}
		}

	return false;
	}
	
	
	
	public boolean Check11(Label l, Node j){
		ArrayList<Node> nodesInSameTerminal = j.getNeighbours();
		ArrayList<Node> deliveries = problem.findDeliveries(j.getAssociatedTerminal());
		
			if(nodesInSameTerminal.size()+1 == deliveries.size()){
				for(Node k : deliveries){
					if(k != j && l.getVisitedNodes().contains(k)==false && k.getLowerTimeWindow() <= j.getLowerTimeWindow() && k.getUpperTimeWindow() <= j.getUpperTimeWindow() && k.getLoadingTime() <= j.getLoadingTime() && k.getCargoLoad() <= j.getCargoLoad()){
						return true;	 //vil ikke utvide til j, bedre  utvide til k
						}
					}
				}
				
		return false;
	}
	
	public boolean Check12(Label l, Node j){
		ArrayList<Node> nodesInSameTerminal = j.getNeighbours();
		ArrayList<Node> pickups = problem.findDeliveries(j.getAssociatedTerminal());
		
			if(nodesInSameTerminal.size()+1 == pickups.size()){
				for(Node k : pickups){
					if(k != j && l.getVisitedNodes().contains(k)==false && k.getLowerTimeWindow() <= j.getLowerTimeWindow() && k.getUpperTimeWindow() <= j.getUpperTimeWindow() && k.getLoadingTime() <= j.getLoadingTime() && k.getCargoLoad() <= j.getCargoLoad()){
						return true;
					}
				}
			}
			
		return false;
	}
	
	//----------------------------------Nytt domineringskriterie---------------------------------------------------------------------//
	
	
	public boolean terminalsAtSamePositions(Label L1, Label L2){
		//Vet at l1 og l2 har beskt samme noder og er like lang
		for(int i=0; i < L1.getVisitedNodes().size(); i++){
			if(L1.getVisitedNodes().get(i).getAssociatedTerminal() != L2.getVisitedNodes().get(i).getAssociatedTerminal()){
				return false; 
			}
		}
		return true;
	}
	
	public int numberOfNodesInLastTerminal(Label l){
		Node n = l.getVisitedNodes().get(l.getVisitedNodes().size()-1);
		
		int counter = 1; 
		for(int i = l.getVisitedNodes().size()-1; i>0; i--){ //sjekker forrige node og gr bakover. 
			if(l.getVisitedNodes().get(i).getAssociatedTerminal() == n.getAssociatedTerminal()){
				counter = counter+1; 
			}
		}
		return counter;
	}
	
	public int symmetricalSolutions(Label l1, Label l2){
		
		boolean terminalsAtSamePositions = terminalsAtSamePositions(l1,l2); 
		if(terminalsAtSamePositions){
			int numberOfNodesInLastTerminal = numberOfNodesInLastTerminal(l1);
			
			for(int i=0; i < l1.getVisitedNodes().size()-numberOfNodesInLastTerminal; i++){
				if(l1.getVisitedNodes().get(i) != l2.getVisitedNodes().get(i)){  //alle noder frem til siste terminal skal vre like i de to labelsene
					return 0; 
				}
			}
			
			double nodeSumLastTerminalL1 = 0;
			double nodeSumLastTerminalL2 = 0;
			
			for(int i = l1.getVisitedNodes().size()-numberOfNodesInLastTerminal; i < l1.getVisitedNodes().size(); i++){
				nodeSumLastTerminalL1 = nodeSumLastTerminalL1 + l1.getVisitedNodes().get(i).getNodeID();
				nodeSumLastTerminalL2 = nodeSumLastTerminalL2 + l2.getVisitedNodes().get(i).getNodeID();
			}
			
			if(nodeSumLastTerminalL1 == nodeSumLastTerminalL2){
				return numberOfNodesInLastTerminal;
			}
		}
		
		return 0;
	}
	

	//-------------------------------Utvide label (en for en)---------------------------------------------------------------------------//
	
	public ArrayList<Label> extendLabel(Label l){
	
			
		if(Parameters.printExtension) {
			System.out.println("---------------------------------------------------------------------------------------------------------------------------------------------------------------");
			System.out.println();
			System.out.println("Extending label: " + l);
		}
		
		ArrayList<Label> extendedLabels = new ArrayList<Label>();						// Ny liste som skal returneres: inneholder alle nye labels som er blitt utvidet fra l
		Node currentNode = l.getCurrentNode();											// Noden vi str i og skal utvide fra 
		
		if(Check1(l)){										// Hvis du fortsatt mangler  beske noen av kundene
			
			ArrayList<Node> notVisited = new ArrayList<Node>();
			for(Node n : problem.getNodes()){
				if(l.getVisitedNodes().contains(n)==false && n.getpOrD() != 0){
					notVisited.add(n);
				}
			}
			
			for (Node newNode : notVisited){					// Kan utvide til alle noder som ikke er i anchorage 
			
				
				// Hvis det finnes en bue fra currentNode og til i OG hvis node i ikke er beskt fr
				if(CheckArcs(currentNode, newNode)){					 
					
					if(Parameters.printExtension) {
						System.out.println();
						System.out.print("Extend to " + newNode.getNodeNumber() + "?"  );
					}
						
						
						if(Parameters.printExtension){
							if(newNode.getpOrD()==1){													
							System.out.print(" (p) ");
							}
							else if(newNode.getpOrD()==-1){
								System.out.print(" (d) ");
							}
						}
						
						
						double newArrivalTime = Math.max((l.getArrivalTime() + problem.getTimeBetweenNodes()[currentNode.getNodeNumber()][newNode.getNodeNumber()]),newNode.getLowerTimeWindow());
			
					
						//Tidssjekk
//						// Dersom ikke tiden det tar fra currentNode og til ny node overskrider vre tidsvindu til den nye noden
						if(Check2(notVisited, newArrivalTime,newNode)){
								double newLoad = l.getAccumulatedLoad() + newNode.getCargoLoad();
	
									//Lastsjekk
									if(Check3(newLoad,newNode, l)){
										
											//Sjekkliste
											if(Check4(l,newNode)){
												counterCheck4 = counterCheck4 + 1;
												if(Parameters.printExtension) {
													System.out.println("Failed check 4");
													}
												continue;
											}
											
											if(Check11(l,newNode)){
												counterCheck11 = counterCheck11 + 1;
												if(Parameters.printExtension) {
													System.out.println("Failed check 11");
													}
												continue;
											}
											
											if(Check10(l,newNode, notVisited)){
												counterCheck10 = counterCheck10 + 1;
												if(Parameters.printExtension) {
													System.out.println("Failed check 10");
													}
												continue;
											}
											
											if(Check6(l,newNode, notVisited)){
												counterCheck6 = counterCheck6 + 1;
												if(Parameters.printExtension) {
													System.out.println("Failed check 6");
													}
												continue;
											}
										
											if(Check5(notVisited, newNode, newLoad)==false){
												counterCheck5 = counterCheck5 + 1;
												if(Parameters.printExtension) {
													System.out.println("Failed draft limit check 2 (check 5)");
													}
												continue;
											}
											
											
											if(Check7(l,newNode)){
												counterCheck7 = counterCheck7 + 1;
												if(Parameters.printExtension) {
													System.out.println("Failed check 7");
													}
												continue;
											}
											if(Check8(l,newNode)){
												counterCheck8 = counterCheck8 + 1;
												if(Parameters.printExtension) {
													System.out.println("Failed check 8");
													}
												continue;
											}
											if(Check9(l,newNode, notVisited)){
												counterCheck9 = counterCheck9 + 1;
												if(Parameters.printExtension) {
													System.out.println("Failed check 9");
													}
												continue;
											}
											
											
											if(Check12(l,newNode)){
												counterCheck12 = counterCheck12 + 1;
												if(Parameters.printExtension) {
													System.out.println("Failed check 12");
													}
												continue;
											}
	
											
											ArrayList<Node> newVisitedNodes = new ArrayList<Node>(l.getVisitedNodes());
											newVisitedNodes.add(newNode); 
											Label newLabel = new Label(++nCreatedLabels,newNode,newArrivalTime,newLoad,newVisitedNodes);
											if(Parameters.printExtension) {
												System.out.println("Creating new label: " + newLabel);
											}
											extendedLabels.add(newLabel);
											numberOfLabelsGenerated = numberOfLabelsGenerated + 1;
										}
										
									else{
										counterCheck3 = counterCheck3 + 1;
										if(Parameters.printExtension) {
											System.out.println("Failed draft limit check 1");
										}
										continue;
									}	
						} //tidssjekk 
						else{
							counterCheck2 = counterCheck2 + 1;
							if(Parameters.printExtension) {
								System.out.println("Failed time check 1");
							}
							continue;
						}
							
				} //check3
			} //for-lkke					
		} //check1
				
		else if(l.getVisitedNodes().size() == problem.getNumberOfNodes() -1){					// Hvis alle kundene er beskt, og du kun skal g til sluttnoden
			
			Node newNode = problem.getNodes().get(problem.getNumberOfNodes()-1);
			
			double newArrivalTime = l.getArrivalTime() + problem.getTimeBetweenNodes()[currentNode.getNodeNumber()][newNode.getNodeNumber()];
			
			double newLoad = l.getAccumulatedLoad();
			
			ArrayList<Node> newVisitedNodes = new ArrayList<Node>(l.getVisitedNodes());
			newVisitedNodes.add(newNode);
			
			Label newLabel = new Label(++nCreatedLabels,newNode,newArrivalTime,newLoad,newVisitedNodes);
			
			numberOfLabelsGenerated = numberOfLabelsGenerated + 1;
			
			
			
			// Model 1:
			if(Parameters.runModel_One){
				if (completeLabels.isEmpty()){
					completeLabels.add(newLabel);
				}
				else{
					if(newLabel.getArrivalTime() < completeLabels.get(0).getArrivalTime()){
						
						completeLabels.remove(0);
						completeLabels.add(newLabel);
						
					}
					
					
				}
			}
			
			
			// Model 2:
			if(Parameters.runModel_Two){
				completeLabels.add(newLabel);
			}
			
			
			
			
		}
		
		
	return extendedLabels;
	
	}

	
	//-------------------------------Dominansesjekk---------------------------------------------------------------------------//
	
	
	public ArrayList<Label> dominanceCheck(ArrayList<Label> extendedLabels, ArrayList<Label> unprocessedLabels){
		
		ArrayList<Label> removeLabelsExtended = new ArrayList<Label>();																		// Mengde for de labels som skal fjernes fra extendedLabels
		ArrayList<Label> removeLabelsUnprocessed = new ArrayList<Label>();																	// Mengde for de labels som skal fjernes fra unprocessedLabels
		
	
		for(Label i :extendedLabels){
			for(Label j : unprocessedLabels){
				
				
				if(removeLabelsExtended.contains(i)==false && removeLabelsUnprocessed.contains(j)==false){ 		//(hvis label 1 har blitt dominert bort av label 2, er det ingen vits i  sjekke label 1 mot label 3) 
					
				// Dersom labelsene har beskt de samme nodene og currentNode er i samme terminal

				if(i.getCurrentNode().getAssociatedTerminal() == j.getCurrentNode().getAssociatedTerminal() && i.getVisitedID() == j.getVisitedID()){ //trenger ikke lenger vre i samme node for  sjekke. SPRSML 1: hvorfor endrer ikke denne testen noe. 
				
					
						double timeExtendedLabel = i.getArrivalTime() + i.getCurrentNode().getLoadingTime() + i.getCurrentNode().getWashingTime();
						double timeUnprocessedLabel = j.getArrivalTime() + j.getCurrentNode().getLoadingTime() + j.getCurrentNode().getWashingTime();
						
						
						if(timeExtendedLabel > timeUnprocessedLabel){
							if(Parameters.printDominance) {
								System.out.println(j + " dominates " + i + "   -Because time when finishing the operations at the node in Label " + j.getId() + " is less than the time when finishing the operations at the node in Label " + i.getId());
							}
							removeLabelsExtended.add(i);			// Legger til label i en labelmengde som skal fjernes fra extendedLabels
						}
						
						else if(timeExtendedLabel < timeUnprocessedLabel){
							if(Parameters.printDominance) {
								System.out.println(i + " dominates " + j + "   -Because time when finishing the operations at the node in Label " + i.getId() + " is less the time when finishing the operations at the node in Label " + j.getId());
							}
							removeLabelsUnprocessed.add(j);			// Legger til label i en labelmengde som skal fjernes fra unprocessedLabels	
						}
			
						else { //(timeExtendedLabel == timeUnprocessedLabel)				// Legger til label der pickupnoder beskes frst (label som skal fjernes fra extenededLabels)
							
							
							
							//nytt domineringskriterie! 
							if(removeLabelsUnprocessed.contains(j)==false && removeLabelsExtended.contains(i)==false){ //hvis ingen av i eller j allerede er dominert bort
								
								// Model 1:
								if(Parameters.runModel_One){
									removeLabelsExtended.add(i); //For modell 1: skal bare velge en av de, ingen skal ha lik tid 
								}
								
								
								// Modell 2:
								if(Parameters.runModel_Two){
									int symmetrical = symmetricalSolutions(i,j); 
									if(symmetrical>0){ //symmetrical = 0: labelsene er ikke symmetriske. Ellers returnerer symmetrical numberOfNodesInLastTerminal
										if (symmetrical>1 ){  //vil sjekke tilfeller der vi har fler enn en node i siste terminal. 
											for(int t = i.getVisitedNodes().size()-symmetrical; t < i.getVisitedNodes().size(); t++){
												if(i.getVisitedNodes().get(t).getCargoLoad() < j.getVisitedNodes().get(t).getCargoLoad()){
													removeLabelsUnprocessed.add(j); //i dominerer j
													//System.out.println(i + " dominates " + j);
													counterDom = counterDom + 1;
													break;
												}
												else if(j.getVisitedNodes().get(t).getCargoLoad() < i.getVisitedNodes().get(t).getCargoLoad()){
													removeLabelsExtended.add(i); // j dominerer i
													//System.out.println(j + " dominates " + i);
													counterDom = counterDom + 1;
													break;
												}
												else
													continue;
											}
										}	
						
									}
								}
								
								
							}
							
						} //end else(time is equal)
								
					}
				}
			}
//		}
		}
			
		for(Label l1 : removeLabelsExtended){
			extendedLabels.remove(l1);
		}
		
		for(Label l2 : removeLabelsUnprocessed){
			unprocessedLabels.remove(l2);
		}
		
		
		return extendedLabels;
	}


	
					

}


